LocalConnectionFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jca.support

## Class LocalConnectionFactoryBean

- java.lang.Object
- - org.springframework.jca.support.LocalConnectionFactoryBean

- All Implemented Interfaces:
    FactoryBean<Object>, InitializingBean

      public class LocalConnectionFactoryBean
      extends Object
      implements FactoryBean<Object>, InitializingBean

  `FactoryBean` that creates a local JCA connection factory in "non-managed" mode (as defined by the Java Connector Architecture specification). This is a direct alternative to a `JndiObjectFactoryBean` definition that obtains a connection factory handle from a J2EE server's naming environment.

  The type of the connection factory is dependent on the actual connector: the connector can either expose its native API (such as a JDBC `DataSource` or a JMS `ConnectionFactory`) or follow the standard Common Client Interface (CCI), as defined by the JCA spec. The exposed interface in the CCI case is `ConnectionFactory`.

  In order to use this FactoryBean, you must specify the connector's `"managedConnectionFactory"` (usually configured as separate JavaBean), which will be used to create the actual connection factory reference as exposed to the application. Optionally, you can also specify a `"connectionManager"`, in order to use a custom ConnectionManager instead of the connector's default.

  NOTE: In non-managed mode, a connector is not deployed on an application server, or more specificially not interacting with an application server. Consequently, it cannot use a J2EE server's system contracts: connection management, transaction management, and security management. A custom ConnectionManager implementation has to be used for applying those services in conjunction with a standalone transaction coordinator etc.

  The connector will use a local ConnectionManager (included in the connector) by default, which cannot participate in global transactions due to the lack of XA enlistment. You need to specify an XA-capable ConnectionManager in order to make the connector interact with an XA transaction coordinator. Alternatively, simply use the native local transaction facilities of the exposed API (e.g. CCI local transactions), or use a corresponding implementation of Spring's PlatformTransactionManager SPI (e.g. `CciLocalTransactionManager`) to drive local transactions.

  Since:
    1.2
  Author:
    Juergen Hoeller
  See Also:
    `setManagedConnectionFactory(javax.resource.spi.ManagedConnectionFactory)`, `setConnectionManager(javax.resource.spi.ConnectionManager)`, `ConnectionFactory`, `Connection.getLocalTransaction()`, `CciLocalTransactionManager`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LocalConnectionFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setConnectionManager(ConnectionManager connectionManager)` Set the JCA ConnectionManager that should be used to create the desired connection factory.
    `void` | `setManagedConnectionFactory(ManagedConnectionFactory managedConnectionFactory)` Set the JCA ManagerConnectionFactory that should be used to create the desired connection factory.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LocalConnectionFactoryBean

          public LocalConnectionFactoryBean()

  - ### Method Detail

    - #### setManagedConnectionFactory

          public void setManagedConnectionFactory(ManagedConnectionFactory managedConnectionFactory)

      Set the JCA ManagerConnectionFactory that should be used to create the desired connection factory.

      The ManagerConnectionFactory will usually be set up as separate bean (potentially as inner bean), populated with JavaBean properties: a ManagerConnectionFactory is encouraged to follow the JavaBean pattern by the JCA specification, analogous to a JDBC DataSource and a JDO PersistenceManagerFactory.

      Note that the ManagerConnectionFactory implementation might expect a reference to its JCA 1.5 ResourceAdapter, expressed through the `ResourceAdapterAssociation` interface. Simply inject the corresponding ResourceAdapter instance into its "resourceAdapter" bean property in this case, before passing the ManagerConnectionFactory into this LocalConnectionFactoryBean.

      See Also:
        `ManagedConnectionFactory.createConnectionFactory()`

    - #### setConnectionManager

          public void setConnectionManager(ConnectionManager connectionManager)

      Set the JCA ConnectionManager that should be used to create the desired connection factory.

      A ConnectionManager implementation for local usage is often included with a JCA connector. Such an included ConnectionManager might be set as default, with no need to explicitly specify one.

      See Also:
        `ManagedConnectionFactory.createConnectionFactory(javax.resource.spi.ConnectionManager)`

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws ResourceException

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Throws:
        `ResourceException`

    - #### getObject

          public Object getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<Object>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<?> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<Object>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<Object>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`